

.cseg
.org 0x18E
;   40 
Delay40:
      push   temp
	  ldi    temp,216            ;  0  40
      out    TCNT0,temp          ;
      
	  ldi    temp,0b00000010     ;  F/8
      out    TCCR0,temp 
      
	  in     temp,TIFR           ;   
      sbrs   temp,0              ;
	  rjmp   pc-2                ;   
	   ldi   temp,0b00000111     ;   
	  out    TIFR,temp
	  pop    temp
ret

;   1,5 
Delay15:
      push   temp
      ldi    temp,67
      out    TCNT0,temp
      ldi    temp,0b00000011     ;   F/64
      out    TCCR0,temp 
      in     temp,TIFR           ;   
      sbrs   temp,0              ;
	  rjmp   pc-2                ;   
	  ldi   temp,0b00000111      ;   
	  out    TIFR,temp
	  pop    temp
ret
;   1 
Delay1:
     push  temp
	 push  temp2
	 ldi   temp,0b00000101       ;   F/1024
	 out   TCCR0,temp
	 ldi   temp2,0x20	
lp1:
	 in    temp,TIFR
	 sbrs  temp,0
     rjmp  pc-2
     subi  temp2,1
	 ldi   temp,0b00000111      ;  
	 out    TIFR,temp           ;  
     brcc  lp1
	 pop   temp2
	 pop   temp
 ret
;      
lcd_com:
      rcall  delay40
      cbi    portb,RS
      push   temp
      mov    temp,lcd
	  andi   temp,0xf0
      out    portb,temp
	  rcall  delay40
	  sbi    portb,E
	 rcall   delay40
      cbi    portb,E
	  cpi    temp2,1
      brsh   pc+8
	  mov    temp,lcd
	  swap   temp
	  andi   temp,0xf0
	  out    portb,temp
      sbi    portb,E
	  rcall  delay40
      cbi    portb,E
      pop    temp            

ret



;     
lcd_data:
      rcall  delay40
      sbi    portb,RS
      push   temp
      mov    temp,lcd
	  andi   temp,0xf0
	  sbr     temp,2
      out    portb,temp 
	  rcall  delay40
	  rcall  delay40
	  sbi    portb,E
	  rcall   delay40
      cbi    portb,E
	  mov    temp,lcd
	  swap   temp
	  andi   temp,0xf0
      sbr     temp,2
	  out    portb,temp
      sbi    portb,E
	  rcall  delay40
      cbi    portb,E
      pop    temp                      

ret

;   
;  n 
; -  n   cur
l_shift:
        ldi    lcd,0b00010000       ;  
	    rcall  lcd_com              ;  
		dec    cur
		brne   l_shift
 ret 

r_shift:
        ldi    lcd,0b00010100       ;  
		rcall  lcd_com
		dec    cur
        brne   r_shift
ret
 ;
 ;   
 output:
        add   temp3,zl
        lpm
		mov  lcd,r0
		rcall  lcd_data
		adiw  z,1
		cp  zl,temp3
		brne	pc-5
ret

;   
clscr:
   ldi     lcd,0x01               ;  0x01
   rcall   lcd_com                ;  0x02-  
   ldi     lcd,0x02
   rcall   lcd_com
   rcall   delay15
ret
